<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: seo_friend_panel.php
| Author: Christian Damsgaard Jrgensen (PMM)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { die("Access Denied"); }

if (file_exists(INFUSIONS."seo_friend/locale/".$settings['locale'].".php")) {
 include INFUSIONS."seo_friend/locale/".$settings['locale'].".php";
} else {
 include INFUSIONS."seo_friend/locale/English.php";
}

include INFUSIONS."seo_friend/infusion_db.php";

require_once INCLUDES."infusions_include.php";

$script_url = explode("/", $_SERVER['PHP_SELF']);
$url_count = count($script_url);
$base_url_count = substr_count(BASEDIR, "/") + 1;
$match_url = "";
while ($base_url_count != 0) {
 $current = $url_count - $base_url_count;
 $match_url .= "/".$script_url[$current];
 $base_url_count--;
}

$seo_settings = get_settings("seo_friend");

define("COMMON_WORDS", ($seo_settings['common_words'] ? TRUE : FALSE));
define("SEP", " ".$seo_settings['title_separator']." ");

$result = dbquery("SELECT * FROM ".DB_SEO_FRIEND." WHERE page='".$match_url."' OR page='".$match_url.(FUSION_QUERY ? "?".FUSION_QUERY : "")."'");
if (dbrows($result) && $seo_settings['disable_seo_friend'] == "0") {
 $data = dbarray($result);
 if ($data['page_title']) {
  $title = $data['page_title'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 }
 if ($data['meta_description']) {
  set_meta("description", $data['meta_description']);
 } else {
  set_meta("description", "");
 }
 if ($data['meta_keywords']) {
  set_meta("keywords", $data['meta_keywords']);
 } else {
  set_meta("keywords", "");
 }
 if ($data['robots']) {
  add_to_head("<meta name='robots' content='".$data['robots']."' />");
 }
 if ($data['add_to_head']) {
  add_to_head(stripslashes($data['add_to_head']));
 }
 if ($data['add_to_footer'] && str_replace(".", "", $settings['version']) >= "70200") {
  add_to_footer(stripslashes($data['add_to_footer']));
 } elseif ($data['add_to_footer']) {
  replace_in_output("</body>", stripslashes($data['add_to_footer'])."\n</body>");
 }
 if ($seo_settings['ga_tracking_code'] && str_replace(".", "", $settings['version']) >= "70200") {
  add_to_footer(stripslashes($seo_settings['ga_tracking_code']));
 } elseif ($seo_settings['ga_tracking_code']) {
  replace_in_output("</body>", stripslashes($seo_settings['ga_tracking_code'])."\n</body>");
 }
} elseif ($seo_settings['disable_seo_friend'] == "0") {
 if ($seo_settings['ga_tracking_code'] && str_replace(".", "", $settings['version']) >= "70200") {
  add_to_footer(stripslashes($seo_settings['ga_tracking_code']));
 } elseif ($seo_settings['ga_tracking_code']) {
  replace_in_output("</body>", stripslashes($seo_settings['ga_tracking_code'])."\n</body>");
 }
 if (COMMON_WORDS) { $common_words = explode("\r\n", $seo_settings['common_words']); }
 if ($match_url == "/articles.php" && isset($_GET['article_id']) && isnum($_GET['article_id'])) {
  $data = dbarray(dbquery("SELECT article_subject, article_snippet FROM ".DB_ARTICLES." WHERE article_id='".$_GET['article_id']."'"));
  $title = $data['article_subject'].SEP.$locale['seo500'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
  if ($seo_settings['autogen_meta_desc'] == "1" && $data['article_snippet']) {
   $description = strip_tags(html_entity_decode(stripslashes($data['article_snippet'])));
   $description = str_replace(array("\r\n", "\r", "\n"), " ", $description);
   $description = trim(preg_replace("/\s+/", " ", $description));
   $description = trimlink($description, 160);
   set_meta("description", $description);
  } else {
   set_meta("description", "");
  }
  if ($seo_settings['autogen_meta_keywords'] == "1" && $data['article_subject']) {
   $keywords = preg_replace("/\s[^\b]{1,2}\s/", " ", html_entity_decode($data['article_subject']));
   if (COMMON_WORDS) $keywords = preg_replace("/\b(".implode("|", $common_words).")\b/", "", $keywords);
   $keywords = explode(" ", trim(preg_replace("/\s+/", " ", $keywords)));
   $keywords = strtolower(implode(", ", $keywords));
   set_meta("keywords", $keywords);
  } else {
   set_meta("keywords", "");
  }
 } elseif ($match_url == "/articles.php" && isset($_GET['cat_id']) && isnum($_GET['cat_id'])) {
  $data = dbarray(dbquery("SELECT article_cat_name, article_cat_description FROM ".DB_ARTICLE_CATS." WHERE article_cat_id='".$_GET['cat_id']."'"));
  $title = $data['article_cat_name'].SEP.$locale['seo500'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
  if ($seo_settings['autogen_meta_desc'] == "1" && $data['article_cat_description']) {
   $description = html_entity_decode(stripslashes($data['article_cat_description']));
   $description = trim(preg_replace("/\s+/", " ", $description));
   $description = trimlink($description, 160);
   set_meta("description", $description);
  } else {
   set_meta("description", "");
  }
  if ($seo_settings['autogen_meta_keywords'] == "1" && $data['article_cat_name']) {
   $keywords = preg_replace("/\s[^\b]{1,2}\s/", " ", html_entity_decode($data['article_cat_name']));
   if (COMMON_WORDS) $keywords = preg_replace("/\b(".implode("|", $common_words).")\b/", "", $keywords);
   $keywords = explode(" ", trim(preg_replace("/\s+/", " ", $keywords)));
   $keywords = strtolower(implode(", ", $keywords));
   set_meta("keywords", $keywords);
  } else {
   set_meta("keywords", "");
  }
 } elseif ($match_url == "/articles.php") {
  $title = $locale['seo500'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/contact.php") {
  $title = $locale['seo501'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/downloads.php" && isset($_GET['cat_id']) && isnum($_GET['cat_id'])) {
  $data = dbarray(dbquery("SELECT download_cat_name, download_cat_description FROM ".DB_DOWNLOAD_CATS." WHERE download_cat_id='".$_GET['cat_id']."'"));
  $title = $data['download_cat_name'].SEP.$locale['seo502'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
  if ($seo_settings['autogen_meta_desc'] == "1" && $data['download_cat_description']) {
   $description = html_entity_decode(stripslashes($data['download_cat_description']));
   $description = trim(preg_replace("/\s+/", " ", $description));
   $description = trimlink($description, 160);
   set_meta("description", $description);
  } else {
   set_meta("description", "");
  }
  if ($seo_settings['autogen_meta_keywords'] == "1" && $data['download_cat_name']) {
   $keywords = preg_replace("/\s[^\b]{1,2}\s/", " ", html_entity_decode($data['download_cat_name']));
   if (COMMON_WORDS) $keywords = preg_replace("/\b(".implode("|", $common_words).")\b/", "", $keywords);
   $keywords = explode(" ", trim(preg_replace("/\s+/", " ", $keywords)));
   $keywords = strtolower(implode(", ", $keywords));
   set_meta("keywords", $keywords);
  } else {
   set_meta("keywords", "");
  }
 } elseif ($match_url == "/downloads.php" && isset($_GET['download_id']) && isnum($_GET['download_id'])) {
  $data = dbarray(dbquery("SELECT download_title, download_description, download_description_short FROM ".DB_DOWNLOADS." WHERE download_id='".$_GET['download_id']."'"));
  $title = $data['download_title'].SEP.$locale['seo502'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
  if ($seo_settings['autogen_meta_desc'] == "1" && $data['download_description_short']) {
   $description = strip_tags(html_entity_decode(stripslashes($data['download_description_short'])));
   $description = str_replace(array("\r\n", "\r", "\n"), " ", $description);
   $description = trim(preg_replace("/\s+/", " ", $description));
   $description = trimlink($description, 160);
   set_meta("description", $description);
  } else {
   set_meta("description", "");
  }
  if ($seo_settings['autogen_meta_keywords'] == "1" && $data['download_description']) {
   $keywords = preg_replace("/\s[^\b]{1,2}\s/", " ", html_entity_decode($data['download_description']));
   if (COMMON_WORDS) $keywords = preg_replace("/\b(".implode("|", $common_words).")\b/", "", $keywords);
   $keywords = explode(" ", trim(preg_replace("/\s+/", " ", $keywords)));
   $keywords = strtolower(implode(", ", $keywords));
   set_meta("keywords", $keywords);
  } else {
   set_meta("keywords", "");
  }
 } elseif (($match_url == "/downloads.php") && !isset($_GET['download_id'])) {
 $title = $locale['seo502'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/edit_profile.php") {
  $title = $locale['seo503'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/faq.php" && isset($_GET['cat_id']) && isnum($_GET['cat_id'])) {
  $data = dbarray(dbquery("SELECT faq_cat_name, faq_cat_description FROM ".DB_FAQ_CATS." WHERE faq_cat_id='".$_GET['cat_id']."'"));
  $title = $data['faq_cat_name'].SEP.$locale['seo504'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
  if ($seo_settings['autogen_meta_desc'] == "1" && $data['faq_cat_description']) {
   $description = html_entity_decode(stripslashes($data['faq_cat_description']));
   $description = trim(preg_replace("/\s+/", " ", $description));
   $description = trimlink($description, 160);
   set_meta("description", $description);
  } else {
   set_meta("description", "");
  }
  if ($seo_settings['autogen_meta_keywords'] == "1" && $data['faq_cat_name']) {
   $keywords = preg_replace("/\s[^\b]{1,2}\s/", " ", html_entity_decode($data['faq_cat_name']));
   if (COMMON_WORDS) $keywords = preg_replace("/\b(".implode("|", $common_words).")\b/", "", $keywords);
   $keywords = explode(" ", trim(preg_replace("/\s+/", " ", $keywords)));
   $keywords = strtolower(implode(", ", $keywords));
   set_meta("keywords", $keywords);
  } else {
 set_meta("keywords", "");
  }
 } elseif ($match_url == "/faq.php") {
  $title = $locale['seo504'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/login.php") {
  $title = $locale['seo505'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/lostpassword.php") {
  $title = $locale['seo506'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/members.php") {
  $title = $locale['seo507'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/messages.php") {
  $title = $locale['seo508'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/news.php" && isset($_GET['readmore']) && isnum($_GET['readmore'])) {
  $data = dbarray(dbquery("SELECT news_subject, news_news FROM ".DB_NEWS." WHERE news_id='".$_GET['readmore']."'"));
  $title = $data['news_subject'].SEP.$locale['seo509'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
  if ($seo_settings['autogen_meta_desc'] == "1" && $data['news_news']) {
   $description = strip_tags(html_entity_decode(stripslashes($data['news_news'])));
   $description = str_replace(array("\r\n", "\r", "\n"), " ", $description);
   $description = trim(preg_replace("/\s+/", " ", $description));
   $description = trimlink($description, 160);
   set_meta("description", $description);
  } else {
   set_meta("description", "");
  }
  if ($seo_settings['autogen_meta_keywords'] == "1" && $data['news_subject']) {
   $keywords = preg_replace("/\s[^\b]{1,2}\s/", " ", html_entity_decode($data['news_subject']));
   if (COMMON_WORDS) $keywords = preg_replace("/\b(".implode("|", $common_words).")\b/", "", $keywords);
   $keywords = explode(" ", trim(preg_replace("/\s+/", " ", $keywords)));
   $keywords = strtolower(implode(", ", $keywords));
   set_meta("keywords", $keywords);
  } else {
   set_meta("keywords", "");
  }
 } elseif ($match_url == "/news.php") {
  $title = $locale['seo509'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/news_cats.php" && isset($_GET['cat_id']) && isnum($_GET['cat_id'])) {
  $data = dbarray(dbquery("SELECT news_cat_name FROM ".DB_NEWS_CATS." WHERE news_cat_id='".$_GET['cat_id']."'"));
  $title = $data['news_cat_name'].SEP.$locale['seo510'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/news_cats.php") {
  $title = $locale['seo510'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/photogallery.php" && isset($_GET['album_id']) && isnum($_GET['album_id'])) {
  $data = dbarray(dbquery("SELECT album_title, album_description FROM ".DB_PHOTO_ALBUMS." WHERE album_id='".$_GET['album_id']."'"));
  $title = $data['album_title'].SEP.$locale['seo511'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
  if ($seo_settings['autogen_meta_desc'] == "1" && $data['album_description']) {
   $description = preg_replace('#\[(.*?)\]#sie', '', html_entity_decode(stripslashes($data['album_description'])));
   $description = str_replace(array("\r\n", "\r", "\n"), " ", $description);
   $description = trim(preg_replace("/\s+/", " ", $description));
   $description = trimlink($description, 160);
   set_meta("description", $description);
  } else {
   set_meta("description", "");
  }
  if ($seo_settings['autogen_meta_keywords'] == "1" && $data['album_title']) {
   $keywords = preg_replace("/\s[^\b]{1,2}\s/", " ", html_entity_decode($data['album_title']));
   if (COMMON_WORDS) $keywords = preg_replace("/\b(".implode("|", $common_words).")\b/", "", $keywords);
   $keywords = explode(" ", trim(preg_replace("/\s+/", " ", $keywords)));
   $keywords = strtolower(implode(", ", $keywords));
   set_meta("keywords", $keywords);
  } else {
   set_meta("keywords", "");
  }
 } elseif ($match_url == "/photogallery.php" && isset($_GET['photo_id']) && isnum($_GET['photo_id'])) {
  $data = dbarray(dbquery("SELECT photo_title, photo_description FROM ".DB_PHOTOS." WHERE photo_id='".$_GET['photo_id']."'"));
  $title = $data['photo_title'].SEP.$locale['seo511'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
  if ($seo_settings['autogen_meta_desc'] == "1" && $data['photo_description']) {
   $description = preg_replace('#\[(.*?)\]#sie', '', html_entity_decode(stripslashes($data['photo_description'])));
   $description = str_replace(array("\r\n", "\r", "\n"), " ", $description);
   $description = trim(preg_replace("/\s+/", " ", $description));
   $description = trimlink($description, 160);
   set_meta("description", $description);
  } else {
   set_meta("description", "");
  }
  if ($seo_settings['autogen_meta_keywords'] == "1" && $data['photo_title']) {
   $keywords = preg_replace("/\s[^\b]{1,2}\s/", " ", html_entity_decode($data['photo_title']));
   if (COMMON_WORDS) $keywords = preg_replace("/\b(".implode("|", $common_words).")\b/", "", $keywords);
   $keywords = explode(" ", trim(preg_replace("/\s+/", " ", $keywords)));
   $keywords = strtolower(implode(", ", $keywords));
   set_meta("keywords", $keywords);
  } else {
   set_meta("keywords", "");
  }
 } elseif ($match_url == "/photogallery.php") {
  $title = $locale['seo511'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/profile.php" && isset($_GET['lookup']) && isnum($_GET['lookup'])) {
  $data = dbarray(dbquery("SELECT user_name FROM ".DB_USERS." WHERE user_id='".$_GET['lookup']."'"));
  $title = $data['user_name'].SEP.$locale['seo512'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/register.php") {
  $title = $locale['seo513'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
 replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/search.php") {
  $title = $locale['seo514'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/submit.php" && isset($_GET['stype']) && $_GET['stype'] == "l") {
  $title = $locale['seo515'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/submit.php" && isset($_GET['stype']) && $_GET['stype'] == "n") {
  $title = $locale['seo516'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/submit.php" && isset($_GET['stype']) && $_GET['stype'] == "a") {
  $title = $locale['seo517'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/submit.php" && isset($_GET['stype']) && $_GET['stype'] == "p") {
  $title = $locale['seo518'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
} elseif ($match_url == "/submit.php" && isset($_GET['stype']) && $_GET['stype'] == "d") {
  $title = $locale['seo519'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/viewpage.php" && isset($_GET['page_id']) && isnum($_GET['page_id'])) {
  $cp_data = dbarray(dbquery("SELECT page_title, page_content FROM ".DB_CUSTOM_PAGES." WHERE page_id='".$_GET['page_id']."'"));
  $title = $cp_data['page_title'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
  if ($seo_settings['autogen_meta_desc'] == "1" && $cp_data['page_content']) {
   ob_start();
   eval("?>".stripslashes($cp_data['page_content'])."<?php ");
   $custompage = ob_get_contents();
   ob_end_clean();
   $description = strip_tags(html_entity_decode($custompage));
   $description = str_replace(array("\r\n", "\r", "\n"), " ", $description);
   $description = trim(preg_replace("/\s+/", " ", $description));
   $description = trimlink($description, 160);
   set_meta("description", $description);
  } else {
   set_meta("description", "");
  }
  if ($seo_settings['autogen_meta_keywords'] == "1" && $cp_data['page_title']) {
   $keywords = preg_replace("/\s[^\b]{1,2}\s/", " ", html_entity_decode($cp_data['page_title']));
   if (COMMON_WORDS) $keywords = preg_replace("/\b(".implode("|", $common_words).")\b/", "", $keywords);
   $keywords = explode(" ", trim(preg_replace("/\s+/", " ", $keywords)));
   $keywords = strtolower(implode(", ", $keywords));
   set_meta("keywords", $keywords);
  } else {
   set_meta("keywords", "");
  }
 } elseif ($match_url == "/weblinks.php" && isset($_GET['cat_id']) && isnum($_GET['cat_id'])) {
  $data = dbarray(dbquery("SELECT weblink_cat_name, weblink_cat_description FROM ".DB_WEBLINK_CATS." WHERE weblink_cat_id='".$_GET['cat_id']."'"));
  $title = $data['weblink_cat_name'].SEP.$locale['seo520'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
  if ($seo_settings['autogen_meta_desc'] == "1" && $data['weblink_cat_description']) {
   $description = html_entity_decode(stripslashes($data['weblink_cat_description']));
   $description = trim(preg_replace("/\s+/", " ", $description));
   $description = trimlink($description, 160);
   set_meta("description", $description);
  } else {
   set_meta("description", "");
  }
  if ($seo_settings['autogen_meta_keywords'] == "1" && $data['weblink_cat_name']) {
   $keywords = preg_replace("/\s[^\b]{1,2}\s/", " ", html_entity_decode($data['weblink_cat_name']));
   if (COMMON_WORDS) $keywords = preg_replace("/\b(".implode("|", $common_words).")\b/", "", $keywords);
   $keywords = explode(" ", trim(preg_replace("/\s+/", " ", $keywords)));
   $keywords = strtolower(implode(", ", $keywords));
   set_meta("keywords", $keywords);
  } else {
   set_meta("keywords", "");
  }
 } elseif ($match_url == "/weblinks.php") {
  $title = $locale['seo520'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/forum/index.php") {
  $title = $locale['seo521'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/forum/post.php" && $_GET['action'] == "newthread") {
  $title = $locale['seo523'].SEP.$locale['seo522'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/forum/post.php" && $_GET['action'] == "reply") {
  $title = $locale['seo524'].SEP.$locale['seo522'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/forum/post.php" && $_GET['action'] == "edit") {
  $title = $locale['seo525'].SEP.$locale['seo522'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/forum/post.php") {
  $title = $locale['seo522'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/forum/postify.php" && $_GET['post'] == "new") {
  $title = $locale['seo523'].SEP.$locale['seo522'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/forum/postify.php" && $_GET['post'] == "reply") {
  $title = $locale['seo524'].SEP.$locale['seo522'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/forum/postify.php" && $_GET['post'] == "edit") {
  $title = $locale['seo525'].SEP.$locale['seo522'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/forum/postify.php") {
  $title = $locale['seo522'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/forum/postreply.php") {
  $title = $locale['seo524'].SEP.$locale['seo522'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
 } elseif ($match_url == "/forum/viewforum.php" && isset($_GET['forum_id']) && isnum($_GET['forum_id'])) {
  $data = dbarray(dbquery("SELECT forum_name, forum_description FROM ".DB_FORUMS." WHERE forum_id='".$_GET['forum_id']."'"));
  $title = $data['forum_name'].SEP.$locale['seo522'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
  if ($seo_settings['autogen_meta_desc'] == "1" && $data['forum_description']) {
   $description = html_entity_decode(stripslashes($data['forum_description']));
   $description = trim(preg_replace("/\s+/", " ", $description));
   $description = trimlink($description, 160);
   set_meta("description", $description);
  } else {
   set_meta("description", "");
  }
  if ($seo_settings['autogen_meta_keywords'] == "1" && $data['forum_name']) {
   $keywords = preg_replace("/\s[^\b]{1,2}\s/", " ", html_entity_decode($data['forum_name']));
   if (COMMON_WORDS) $keywords = preg_replace("/\b(".implode("|", $common_words).")\b/", "", $keywords);
   $keywords = explode(" ", trim(preg_replace("/\s+/", " ", $keywords)));
   $keywords = strtolower(implode(", ", $keywords));
   set_meta("keywords", $keywords);
  } else {
   set_meta("keywords", "");
  }
 } elseif ($match_url == "/forum/viewthread.php" && isset($_GET['thread_id']) && isnum($_GET['thread_id'])) {
  $data = dbarray(dbquery("
   SELECT tt.thread_subject, tp.post_message FROM ".DB_THREADS." tt
   INNER JOIN ".DB_POSTS." tp USING (thread_id)
   WHERE thread_id='".$_GET['thread_id']."'
   ORDER BY post_id LIMIT 0,1
  "));
  $title = $data['thread_subject'].SEP.$locale['seo522'].($seo_settings['title_suffix'] ? SEP.$seo_settings['title_suffix'] : "");
  replace_in_output("<title>(.*?)</title>", "<title>".$title."</title>");
  if ($seo_settings['autogen_meta_desc'] == "1" && $data['post_message']) {
   $description = preg_replace('#\[(.*?)\]#sie', '', html_entity_decode(stripslashes($data['post_message'])));
   $description = str_replace(array("\r\n", "\r", "\n"), " ", $description);
   $description = trim(preg_replace("/\s+/", " ", $description));
   $description = trimlink($description, 160);
   set_meta("description", $description);
  } else {
   set_meta("description", "");
  }
  if ($seo_settings['autogen_meta_keywords'] == "1" && $data['thread_subject']) {
   $keywords = preg_replace("/\s[^\b]{1,2}\s/", " ", html_entity_decode($data['thread_subject']));
   if (COMMON_WORDS) $keywords = preg_replace("/\b(".implode("|", $common_words).")\b/", "", $keywords);
   $keywords = explode(" ", trim(preg_replace("/\s+/", " ", $keywords)));
   $keywords = strtolower(implode(", ", $keywords));
   set_meta("keywords", $keywords);
  } else {
  set_meta("keywords", "");
  }
 } else {
  set_meta("description", "");
  set_meta("keywords", "");
 }
}
?>